/***************************************/
/*  Use MADS http://mads.atari8.info/  */
/*  Mode: DLI (char mode)              */
/***************************************/

	icl "xxlatari.h"

	org $00

fcnt	.ds 2
fadr	.ds 2
fhlp	.ds 2
cloc	.ds 1
regA	.ds 1
regX	.ds 1
regY	.ds 1

* ---	BASIC switch OFF
	org $2000\ mva #$ff portb\ rts\ ini $2000

* ---	MAIN PROGRAM
	org $2000
ant	dta $42,a(scr)
	dta $82,$02,$02,$02,$02,$02,$02,$02,$82,$02,$02,$02,$02,$02,$02,$02
	dta $82,$02,$02,$02,$02,$02,$02,$02,$82,$02,$82,$02,$22
	dta $41,a(ant)

scr	ins "xxlatari.scr"

	.ALIGN $0400
fnt	ins "xxlatari.fnt"

	ift USESPRITES
	.ALIGN $0800
	.ds $0300
pmg	SPRITES
	eif

;--- RMT music player
MODUL	equ $8000				;address of RMT module
KEY		equ $2fc				;keypressed code
VLINE	equ 16					;screen line for synchronization

main

;--- RMT music player
	jsr music

* ---	init PMG

	ift USESPRITES
	mva >pmg pmbase		;missiles and players data address
	mva #$03 pmcntl		;enable players and missiles
	eif

	lda:cmp:req $14		;wait 1 frame

	sei			;stop IRQ interrupts
	mva #$00 nmien		;stop NMI interrupts
	sta dmactl
	mva #$fe portb		;switch off ROM to get 16k more ram

	mwa #NMI $fffa		;new NMI handler

	mva #1 vscrol

	mva #$c0 nmien		;switch on NMI+DLI again

	ift CHANGES		;if label CHANGES defined

_lp
	lda trig0		; FIRE #0
	beq stop

	lda trig1		; FIRE #1
	beq stop

	lda consol		; START
	and #1
	beq stop

	lda skctl
	and #$04
	bne _lp			;wait to press any key; here you can put any own routine
stop
	mva #$00 pmcntl		;PMG disabled
	tax
	sta:rne hposp0,x+

	mva #$ff portb		;ROM switch on
	mva #$40 nmien		;only NMI interrupts, DLI disabled
	cli			;IRQ enabled

	rts			;return to ... DOS

	els

null	jmp DLI.dli1		;CPU is busy here, so no more routines allowed

	eif


* ---	DLI PROGRAM

	?old_dli = *

.local	DLI

dli1
	lda vcount
	cmp #$02
	bne dli1
	:3 sta wsync
	DLINEW dli6


dli_start

dli6
	sta regA
	stx regX

c2	lda #$DE
c3	ldx #$D2
	sta wsync		;line=16
	sta color1
	stx color2
	DLINEW dli7 1 1 0

dli7
	sta regA
	stx regX

	sta wsync		;line=80
	sta wsync		;line=81
	sta wsync		;line=82
	sta wsync		;line=83
	sta wsync		;line=84
	sta wsync		;line=85
c4	lda #$00
c5	ldx #$0E
	sta wsync		;line=86
	sta color1
	stx color2
c6	lda #$D0
c7	ldx #$FC
	sta wsync		;line=87
	sta color1
	stx color2
	sta wsync		;line=88
	sta wsync		;line=89
c8	lda #$FA
	sta wsync		;line=90
	sta color2
	sta wsync		;line=91
c9	lda #$F6
	sta wsync		;line=92
	sta color2
	sta wsync		;line=93
c10	lda #$F4
	sta wsync		;line=94
	sta color2
	sta wsync		;line=95
	sta wsync		;line=96
c11	lda #$0C
	sta wsync		;line=97
	sta color2
c12	lda #$DE
c13	ldx #$10
	sta wsync		;line=98
	sta color1
	stx color2
	DLINEW DLI.dli2 1 1 0

dli2
	sta regA
	lda >fnt+$400*$01
	sta wsync		;line=144
	sta chbase
	DLINEW dli8 1 0 0

dli8
	sta regA
	stx regX

c14	lda #$00
c15	ldx #$0E
	sta wsync		;line=208
	sta color1
	stx color2
	DLINEW dli3 1 1 0

dli3
	sta regA
	lda >fnt+$400*$00
	sta wsync		;line=224
	sta chbase

	lda regA
	rti

.endl

;---

CHANGES = 1
;---

.proc	NMI

	bit nmist
	bpl VBL

	jmp DLI.dli_start
dliv	equ *-2

VBL
	sta regA
	stx regX
	sty regY

	sta nmist		;reset NMI flag

	mwa #ant dlptr		;ANTIC address program

	mva #%00111101 dmactl	;set new screen's width

	inc cloc		;little timer

;--- first line of screen initialization

	lda >fnt+$400*$00
	sta chbase
c0	lda #$00
	sta colbak
	sta color0
	sta color1
	sta color2
	sta color3
	lda #$01
	sta gtictl
s0	lda #$03
	sta sizep2
	sta sizep3
x0	lda #$72
	sta hposp2
x1	lda #$52
	sta hposp3
c1	lda #$A4
	sta colpm2
	sta colpm3

	mwa #DLI.dli_start dliv	;set the first address of DLI interrupt

;this area is for yours routines


;--- RMT music player
 jsr RASTERMUSICTRACKER+3	;1 play




quit
	lda regA
	ldx regX
	ldy regY
	rti

.endp


;--- RMT music player
STEREOMODE	equ 0				;0 => compile RMTplayer for mono 4 tracks

	icl "rmtplayr.a65"			;include RMT player routine

 org $8000
 ins "xxlatari.rmt",6 ;include music RMT module

;--
music	ldx #<MODUL					;low byte of RMT module to X reg
	ldy #>MODUL					;hi byte of RMT module to Y reg
	lda #0						;starting song line 0-255 to A reg
	jsr RASTERMUSICTRACKER		;Init
;Init returns instrument speed (1..4 => from 1/screen to 4/screen)
	tay
	lda tabpp-1,y
	sta acpapx2+1				;sync counter spacing
	lda #16+0
	sta acpapx1+1				;sync counter init
;
	lda #255
	sta KEY						;no key pressed
;
loop
acpapx1	lda #$ff				;parameter overwrite (sync line counter value)
	clc
acpapx2	adc #$ff				;parameter overwrite (sync line counter spacing)
	cmp #156
	bcc lop4
	sbc #156
lop4
	sta acpapx1+1
	rts

tabpp  dta 156,78,52,39			;line counter spacing table for instrument speed from 1 to 4

;---
	ini main
;---

	opt l-

.MACRO	SPRITES
	.ds $100
	.ds $100
	.ds $100
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 FF FF FF FF FF FF FF FF
	.he FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF
	.he FF FF FF FF FF FF FF FF FF FF FF FF FF FF 00 00
	.he 00 00 00 00 00 00 00 00 00 00 FF FF FF FF FF FF
	.he FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF
	.he FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF
	.he FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF
	.he FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF
	.he FF FF FF FF FF FF FF FF 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 FF FF FF FF FF FF FF FF

	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 FF FF FF FF FF FF FF FF
	.he FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF
	.he FF FF FF FF FF FF FF FF FF FF FF FF FF FF 00 00
	.he 00 00 00 00 00 00 00 00 00 00 FF FF FF FF FF FF
	.he FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF
	.he FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF
	.he FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF
	.he FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF
	.he FF FF FF FF FF FF FF FF 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 FF FF FF FF FF FF FF FF
.ENDM

USESPRITES = 1

.MACRO	DLINEW
	mva <:1 NMI.dliv
	ift [>?old_dli]<>[>:1]
	mva >:1 NMI.dliv+1
	eif

	ift :2
	lda regA
	eif

	ift :3
	ldx regX
	eif

	ift :4
	ldy regY
	eif

	rti

	.def ?old_dli = *
.ENDM

